unit ponpon;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }
    procedure showmap;
    procedure check;
    procedure init;

  end;


var
  Form1: TForm1;
  pon,block,igaiga,doll,space,energy:tbitmap;
  screen,scores:tbitmap;
  map: array [0..19,0..12] of integer;
  px,py:integer;
  score,hiscore:integer;
  life:integer;
  esas:integer;
  fullscreen,rev:boolean;
implementation

{$R *.dfm}
{$R PON.res}



procedure TForm1.FormCreate(Sender: TObject);

begin
screen:=tbitmap.Create;
scores:=tbitmap.Create;
pon:=tbitmap.Create;
igaiga:=tbitmap.Create;
doll:=tbitmap.Create;
block:=tbitmap.Create;
space:=tbitmap.Create;
energy:=tbitmap.Create;

space.Canvas.Brush.Color:=clblack;
space.Canvas.pen.Color:=clblack;
space.canvas.FillRect(rect(0,0,32,32));

pon.LoadFromResourceName(hinstance,'PONPON');
igaiga.LoadFromResourceName(hinstance,'IGAIGA');
doll.LoadFromResourceName(hinstance,'DOLL');
BLOCK.LoadFromResourceName(hInstance,'BLOCK');
energy.LoadFromResourceName(hInstance,'ENERGY');
block.LoadFromResourceName(hInstance,'BLOCK');
init;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
screen.free;
scores.free;
pon.free;
igaiga.free;
doll.free;
block.free;
space.free;
energy.free;

end;

procedure TForm1.showmap;
var
x,y,i:integer;
maxx,maxy:integer;
begin

screen.Canvas.Brush.Color:=clblack;
screen.Canvas.pen.Color:=clblack;

screen.Canvas.Fillrect(rect(0,0,640,480));

for x:=0 to 19 do
begin
 for y:=0 to  12 do
 begin
 if map[x,y]=0  then  screen.Canvas.Draw(x*32,y*32,space);
 if map[x,y]=1  then  screen.Canvas.Draw(x*32,y*32,block);
 if map[x,y]=2  then  screen.Canvas.Draw(x*32,y*32,igaiga);
 if map[x,y]=3  then  screen.Canvas.Draw(x*32,y*32,doll);

 end;
 end;

screen.Canvas.Draw(px*32,py*32,pon);

scores.Width:=160;
scores.height:=480;

scores.Canvas.Brush.Color:=clblack;
scores.canvas.pen.Color:=clblack;
scores.canvas.Fillrect(rect(0,0,160,480));

scores.canvas.Font.color:=clwhite;
scores.canvas.Font.size:=20;
scores.canvas.TextOut(10,100,'PONPON');
scores.canvas.Font.size:=16;
scores.canvas.TextOut(10,150,'by uF');

scores.Canvas.Font.size:=14;
scores.canvas.TextOut(10,180,'HI-SCORE:'+inttostr(hiscore));
scores.canvas.TextOut(10,200,'SCORE:'+inttostr(score));
scores.canvas.TextOut(10,250,'LIFE:');
for i:=1 to life do begin
x:= (i-1)*24+10;
y:=280;
scores.Canvas.stretchDraw(rect(x,y,x+24,y+24),pon);
end;



if not fullscreen then
begin
form1.width:=800;
form1.Height:=518;
form1.borderstyle:=bsdialog;
form1.Left:=100;
form1.top:=100;
canvas.Draw(0,0,screen);
canvas.Draw(640,0,scores);

end
else

begin
//maxx:=1366;
//maxy:=768;
maxx:=Monitor.Width;
maxy:=Monitor.Height;
form1.Left:=0;
form1.Top:=0;
form1.width:=maxx;
form1.height:=maxy;
form1.borderstyle:=bsnone;


canvas.stretchDraw(rect(0,0,round(maxx*0.8),maxy),screen);
canvas.stretchDraw(rect(round(maxx*0.8),0,maxx,maxy),scores);
end;


end;

procedure TForm1.FormPaint(Sender: TObject);
begin
showmap;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if (map[px,py+1]<>1) and (rev=false) then py:=py+1;
if (map[px,py-1]<>1) and (rev=true) then py:=py-1;
if (map[px,py+1]=1) and (rev=false) then rev:=true;
if (map[px,py-1]=1) and (rev=true) then rev:=false;




showmap;
check;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);


  begin
  if (ssAlt in Shift) and (Key=VK_RETURN) then
begin
  fullscreen:=not fullscreen;
  key:=0;

end;

if key=vk_left then
begin
if map[px-1,py]<>1 then px:=px-1;

end;

if key=vk_right then
begin
if map[px+1,py]<>1 then px:=px+1;

end;

{
if (map[px,py+1]<>1) and (rev=false) then py:=py+1;
if (map[px,py-1]<>1) and (rev=true) then py:=py-1;
if (map[px,py+1]=1) and (rev=false) then rev:=true;
if (map[px,py-1]=1) and (rev=true) then rev:=false;
}



showmap;
check;
end;
procedure TForm1.check;
var
x,y:integer;
begin
if map[px,py]=3 then
begin
score:=score+100;
if hiscore<score then hiscore:=score;
map[px,py]:=0;
Windows.Beep(1000, 100)

end;

esas:=0;
for x:=0 to 19 do
begin
 for y:=0 to  12 do
 begin
 if map[x,y]=3 then esas:=esas+1;
 end;
end;
//showmessage(inttostr(esas));

if esas=0 then
begin
showmap;
for x:=12 to 25 do begin
Windows.Beep(x*40, 200);
end;

timer1.Enabled:=false;
showmessage('Xe[WNA!!');
timer1.Interval:=abs(timer1.Interval-50);

init;
timer1.Enabled:=true;
end;


if map[px,py]=2 then
begin
life:=life-1;
Windows.Beep(100, 100);
end;

if life<=0 then
begin
showmap;
Windows.Beep(50, 250);
timer1.Enabled:=false;
showmessage('Q[I[o[łB');
score:=0;
init;
timer1.Interval:=200;
timer1.Enabled:=true;

end;

end;

procedure TForm1.init;
var x,y,i:integer;
begin
randomize;
screen.Width:=640;
screen.Height:=480;
life:=5;



screen.Canvas.Brush.Color:=clblack;
screen.Canvas.pen.Color:=clblack;

screen.Canvas.Fillrect(rect(0,0,640,480));

for x:=0 to 19 do
begin
 for y:=0 to  12 do
 begin
     map[x,y]:=0;
 end;
end;

for x:=0 to 19 do
begin
 for y:=0 to  3 do
 begin
 if y<>4 then map[x,y*4]:=1;
 end;
  map[x,12]:=1;
  map[x,0]:=1;
 end;
 for y:=0 to  12 do
 begin
  map[0,y]:=1;
  map[19,y]:=1;
if (y>0) and (y<12) then  map[2,y]:=0;
if (y>0) and (y<12) then  map[17,y]:=0;

 end;



    esas:=0;
 for y:=0 to 2 do
 begin

 for i:=1 to 3 do
 begin
  x:=round(random*11)+3;
    map[x,y*4+3]:=2;
    map[x+1,y*4+3]:=3;
    map[x+2,y*4+3]:=2;
 end;
end;

   px:=1;
   py:=1;


showmap;


end;

end.
